import { defineStore } from "pinia";
import axios from "axios";
import formatPeriod from "@/services/formatPeriod.js";

export const useReminderStore = defineStore({
  id: "reminderStore",
  state: () => ({
    reminders: [],
  }),
  actions: {
    fetchReminder() {
      const response = axios.get(import.meta.env.VITE_APP_API_URL + "reminder");
      response.then((res) => {
        if (res.data._embedded) {
          this.reminders = res.data._embedded.reminder.map((reminder) => ({
            ...reminder,
            time: formatPeriod(reminder.time),
          }));
        }
      });
    },

    getReminder() {
      if (this.reminders.length === 0) {
        this.fetchReminder();
      }
      return this.reminders;
    },
  },
});
