package es.mdef.mipediatra.assemblers;

import es.mdef.mipediatra.controllers.AutonomousCommunitiesController;
import es.mdef.mipediatra.entities.AutonomousCommunityEntity;
import es.mdef.mipediatra.models.autonomous_community.AutonomousCommunityListModel;
import es.mdef.mipediatra.models.autonomous_community.AutonomousCommunityModel;
import es.mdef.mipediatra.models.autonomous_community.AutonomousCommunityPostModel;
import es.mdef.mipediatra.models.autonomous_community.AutonomousCommunityPutModel;
import es.mdef.mipediatra.services.AssemblerService;
import org.springframework.hateoas.server.mvc.WebMvcLinkBuilder;
import org.springframework.stereotype.Component;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;

@Component
public class AutonomousCommunityAssembler extends AssemblerService<AutonomousCommunityEntity, AutonomousCommunityModel, AutonomousCommunityPostModel, AutonomousCommunityPutModel, AutonomousCommunityListModel> {

    public AutonomousCommunityAssembler() {
        super(() -> linkTo(WebMvcLinkBuilder.methodOn(AutonomousCommunitiesController.class).getAll()).withSelfRel());
    }

    @Override
    public AutonomousCommunityModel toModel(AutonomousCommunityEntity autonomousCommunity) {
        AutonomousCommunityModel model = new AutonomousCommunityModel();
        model.setName(autonomousCommunity.getName());
        model.add(linkTo(methodOn(AutonomousCommunitiesController.class).getById(autonomousCommunity.getId())).withSelfRel());
        return model;
    }

    @Override
    public AutonomousCommunityListModel toListModel(AutonomousCommunityEntity autonomousCommunity) {
        AutonomousCommunityListModel model = new AutonomousCommunityListModel();

        model.setName(autonomousCommunity.getName());

        model.add(linkTo(methodOn(AutonomousCommunitiesController.class).getById(autonomousCommunity.getId())).withSelfRel());
        return model;
    }

    @Override
    public AutonomousCommunityEntity toEntity(AutonomousCommunityPostModel model) {
        return new AutonomousCommunityEntity(model.getName());
    }

    @Override
    public AutonomousCommunityEntity toEntity(AutonomousCommunityPutModel model) {
        return new AutonomousCommunityEntity(model.getName());
    }

    @Override
    public AutonomousCommunityEntity update(AutonomousCommunityEntity entity, AutonomousCommunityPutModel model) {
        entity.setName(model.getName());
        return entity;
    }
}
