package es.mdef.mipediatra.assemblers;

import es.mdef.mipediatra.controllers.FileController;
import es.mdef.mipediatra.entities.FileEntity;
import es.mdef.mipediatra.models.PostModel;
import es.mdef.mipediatra.models.PutModel;
import es.mdef.mipediatra.models.file.FileListModel;
import es.mdef.mipediatra.models.file.FileModel;
import es.mdef.mipediatra.services.AssemblerService;
import org.springframework.hateoas.server.mvc.WebMvcLinkBuilder;
import org.springframework.stereotype.Component;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;

@Component
public class FileAssembler extends AssemblerService<FileEntity, FileModel, PostModel, PutModel, FileListModel> {
    public FileAssembler() {
        super(() -> WebMvcLinkBuilder.linkTo(methodOn(FileController.class).getAll()).withSelfRel());
    }

    public FileModel toModel(FileEntity entity) {
        if (entity == null) {
            return null;
        }
        FileModel model = new FileModel();
        model.setName(entity.getName());
        model.setSize(entity.getSize());
        model.setData(entity.getData());
        model.setType(entity.getType());
        model.add(linkTo(methodOn(FileController.class).getById(entity.getId())).withSelfRel());
        return model;
    }

    @Override
    public FileListModel toListModel(FileEntity entity) {
        if (entity == null) {
            return null;
        }
        FileListModel model = new FileListModel();
        model.setName(entity.getName());
        model.setSize(entity.getSize());
        model.setData(entity.getData());
        model.setType(entity.getType());
        model.add(linkTo(methodOn(FileController.class).getById(entity.getId())).withSelfRel());
        return model;
    }

    @Override
    public FileEntity toEntity(PostModel model) {
        return null;
    }

    @Override
    public FileEntity toEntity(PutModel model) {
        return null;
    }

    @Override
    public FileEntity update(FileEntity entity, PutModel model) {
        return null;
    }
}
