package es.mdef.mipediatra.assemblers;

import es.mdef.mipediatra.models.reminder.ReminderListModel;
import es.mdef.mipediatralib.interfaces.IPerson;
import es.mdef.mipediatralib.interfaces.IReminder;
import org.springframework.hateoas.CollectionModel;
import org.springframework.stereotype.Component;

import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class ReminderAssembler {
    public CollectionModel<ReminderListModel> toCollectionModel(Collection<IReminder> entities) {
        List<ReminderListModel> modelList = entities.stream()
                .map(this::toListModel)
                .collect(Collectors.toList());
        return CollectionModel.of(modelList);
    }

    private ReminderListModel toListModel(IReminder iReminder) {
        ReminderListModel model = new ReminderListModel();
        model.setName(iReminder.getName());
        model.setTime(iReminder.getTimeLeft());
        model.setPatientName(((IPerson) iReminder.getPatient()).getName());
        return model;
    }
}
