package es.mdef.mipediatra.assemblers;

import es.mdef.mipediatra.controllers.SymptomsController;
import es.mdef.mipediatra.entities.SymptomEntity;
import es.mdef.mipediatra.models.PostModel;
import es.mdef.mipediatra.models.PutModel;
import es.mdef.mipediatra.models.symptom.SymptomModel;
import es.mdef.mipediatra.models.symptom.SymptomsListModel;
import es.mdef.mipediatra.services.AssemblerService;
import org.springframework.stereotype.Component;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;

@Component
public class SymptomAssembler extends AssemblerService<SymptomEntity, SymptomModel, PostModel, PutModel, SymptomsListModel> {

    public SymptomAssembler() {
        super(() -> linkTo(methodOn(SymptomsController.class).getAll()).withSelfRel());
    }

    @Override
    public SymptomModel toModel(SymptomEntity symptom) {
        SymptomModel model = new SymptomModel();
        model.setName(symptom.getName());
        model.add(linkTo(methodOn(SymptomsController.class).getById(symptom.getId())).withSelfRel());
        return model;
    }

    @Override
    public SymptomsListModel toListModel(SymptomEntity symptom) {
        SymptomsListModel listModel = new SymptomsListModel();
        listModel.setName(symptom.getName());
        listModel.add(linkTo(methodOn(SymptomsController.class).getById(symptom.getId())).withSelfRel());
        return listModel;
    }

    @Override
    public SymptomEntity toEntity(PostModel model) {
        return null;
    }

    @Override
    public SymptomEntity toEntity(PutModel model) {
        return null;
    }

    @Override
    public SymptomEntity update(SymptomEntity entity, PutModel model) {
        return null;
    }
}