package es.mdef.mipediatra.assemblers.vaccine;

import es.mdef.mipediatra.controllers.VaccineDetailsController;
import es.mdef.mipediatra.controllers.VaccinesController;
import es.mdef.mipediatra.entities.VaccineDetailsEntity;
import es.mdef.mipediatra.entities.VaccineEntity;
import es.mdef.mipediatra.models.vaccine.VaccineModel;
import org.springframework.stereotype.Component;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;

@Component
public class VaccineAssembler {
    public VaccineModel toModel(VaccineEntity entity) {
        VaccineModel model = new VaccineModel();

        model.setDose(entity.getDose() != 0 ? entity.getDose() + "º dosis" : "Anual");
        model.setName(entity.getVaccineDetails().getName());
        model.setShortName(entity.getVaccineDetails().getShortName());

        model.add(linkTo(methodOn(VaccinesController.class).getById(entity.getId())).withSelfRel());
        model.add(linkTo(methodOn(VaccineDetailsController.class).getById(((VaccineDetailsEntity) entity.getVaccineDetails()).getId())).withRel("vaccinedetails"));
        return model;
    }
}