package es.mdef.mipediatra.controllers;

import es.mdef.mipediatra.entities.MeasurementEntity;
import es.mdef.mipediatra.models.measurement.MeasurementModel;
import es.mdef.mipediatra.models.measurement.MeasurementPostModel;
import es.mdef.mipediatra.models.measurement.MeasurementPutModel;
import es.mdef.mipediatra.models.measurement.MeasurementsListModel;
import es.mdef.mipediatra.services.ControllerService;
import es.mdef.mipediatra.services.CrudService;
import es.mdef.mipediatra.services.impl.MeasurementService;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("/measurements")
public class MeasurementsController implements ControllerService<MeasurementEntity, MeasurementModel, MeasurementPostModel, MeasurementPutModel, MeasurementsListModel> {
    private final MeasurementService measurementService;

    public MeasurementsController(MeasurementService measurementService) {
        this.measurementService = measurementService;
    }

    @Override
    public CrudService<MeasurementEntity, MeasurementModel, MeasurementPostModel, MeasurementPutModel, MeasurementsListModel> getService() {
        return measurementService;
    }
}