package es.mdef.mipediatra.controllers;

import es.mdef.mipediatra.models.reminder.ReminderListModel;
import es.mdef.mipediatra.services.impl.ReminderService;
import org.springframework.hateoas.CollectionModel;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("/reminder")
public class ReminderController {
    private final ReminderService reminderService;

    public ReminderController(ReminderService reminderService) {
        this.reminderService = reminderService;
    }

    @GetMapping
    public ResponseEntity<CollectionModel<ReminderListModel>> getAll() {
        return ResponseEntity.ok(reminderService.readAll());
    }
}
