package es.mdef.mipediatra.controllers;

import es.mdef.mipediatra.entities.SymptomEntity;
import es.mdef.mipediatra.models.PostModel;
import es.mdef.mipediatra.models.PutModel;
import es.mdef.mipediatra.models.symptom.SymptomModel;
import es.mdef.mipediatra.models.symptom.SymptomsListModel;
import es.mdef.mipediatra.services.ControllerService;
import es.mdef.mipediatra.services.CrudService;
import es.mdef.mipediatra.services.impl.SymptomService;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("/symptoms")
public class SymptomsController implements ControllerService<SymptomEntity, SymptomModel, PostModel, PutModel, SymptomsListModel> {
    private final SymptomService symptomService;

    public SymptomsController(SymptomService symptomService) {
        this.symptomService = symptomService;
    }

    @Override
    public CrudService<SymptomEntity, SymptomModel, PostModel, PutModel, SymptomsListModel> getService() {
        return symptomService;
    }
}
