package es.mdef.mipediatra.data;

import es.mdef.mipediatra.data.impl.AutonomousCommunitySeeder;
import es.mdef.mipediatra.data.impl.PatientSeeder;
import es.mdef.mipediatra.data.impl.SymptomSeeder;
import es.mdef.mipediatra.data.impl.VaccinesSeeder;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Service;

@Service
public class SeedDb {
    private final Seeder autonomousCommunitySeeder;
    private final Seeder symptomSeeder;
    private final Seeder vaccinesSeeder;
    private final Seeder patientSeeder;

    public SeedDb(AutonomousCommunitySeeder autonomousCommunitySeeder,
                  SymptomSeeder symptomSeeder,
                  VaccinesSeeder vaccinesSeeder,
                  PatientSeeder patientSeeder) {
        this.autonomousCommunitySeeder = autonomousCommunitySeeder;
        this.symptomSeeder = symptomSeeder;
        this.vaccinesSeeder = vaccinesSeeder;
        this.patientSeeder = patientSeeder;
    }

    @EventListener
    public void seed(ContextRefreshedEvent event) {
        autonomousCommunitySeeder.seed();
        symptomSeeder.seed();
        vaccinesSeeder.seed();
        patientSeeder.seed();
    }
}
