package es.mdef.mipediatra.data.impl;

import es.mdef.mipediatra.data.Seeder;
import es.mdef.mipediatra.entities.AutonomousCommunityEntity;
import es.mdef.mipediatra.repositories.AutonomousCommunityRepository;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.List;

@Service
public class AutonomousCommunitySeeder implements Seeder {
    private final AutonomousCommunityRepository autonomousCommunityRepository;
    private final List<String> AUTONOMOUS_COMMUNITIES_NAMES = Arrays.asList(
            "Andalucía",
            "Aragón",
            "Principado de Asturias",
            "Islas Baleares",
            "Canarias",
            "Cantabria",
            "Castilla-La Mancha",
            "Castilla y León",
            "Cataluña",
            "Ceuta",
            "Comunidad de Madrid",
            "Comunidad Foral de Navarra",
            "Comunidad Valenciana",
            "Extremadura",
            "Galicia",
            "La Rioja",
            "Melilla",
            "País Vasco",
            "Región de Murcia"
    );

    public AutonomousCommunitySeeder(AutonomousCommunityRepository autonomousCommunityRepository) {
        this.autonomousCommunityRepository = autonomousCommunityRepository;
    }

    @Override
    public void seed() {
        if (this.autonomousCommunityRepository.findAll().isEmpty()) {
            for (String communityName : AUTONOMOUS_COMMUNITIES_NAMES) {
                AutonomousCommunityEntity community = new AutonomousCommunityEntity(communityName);
                this.autonomousCommunityRepository.save(community);
            }
        }
    }
}
