package es.mdef.mipediatra.data.impl;

import es.mdef.mipediatra.data.Seeder;
import es.mdef.mipediatra.entities.SymptomEntity;
import es.mdef.mipediatra.repositories.SymptomRepository;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.List;

@Service
public class SymptomSeeder implements Seeder {
    public static final List<String> SYMPTOM_NAMES = Arrays.asList(
            "Cambios en la micción",
            "Diarrea",
            "Dolor abdominal",
            "Dolor de cabeza",
            "Dolor de espalda",
            "Dolor de garganta",
            "Dolor en las articulaciones",
            "Dolor en el pecho",
            "Dolor muscular",
            "Fatiga",
            "Fiebre",
            "Mareo",
            "Náuseas",
            "Pérdida del apetito",
            "Picazón",
            "Sangrado",
            "Sarpullido",
            "Tos",
            "Cambios en la visión",
            "Otros"
    );
    private final SymptomRepository symptomRepository;

    public SymptomSeeder(SymptomRepository symptomRepository) {
        this.symptomRepository = symptomRepository;
    }

    @Override
    public void seed() {
        if (symptomRepository.findAll().isEmpty()) {
            for (String symptomName : SYMPTOM_NAMES) {
                SymptomEntity symptom = new SymptomEntity(symptomName);
                symptomRepository.save(symptom);
            }
        }
    }
}