package es.mdef.mipediatra.models.consultation;

import es.mdef.mipediatra.constants.ConsultationType;
import es.mdef.mipediatra.entities.FileEntity;
import es.mdef.mipediatra.entities.PatientEntity;
import es.mdef.mipediatra.entities.SymptomEntity;
import es.mdef.mipediatra.models.PostModel;
import es.mdef.mipediatra.models.measurement.MeasurementPostModel;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.ZonedDateTime;
import java.util.Set;

@EqualsAndHashCode(callSuper = true)
@Data
public class ConsultationPostModel extends PostModel {
    private ConsultationType type;
    private String center;
    private String comments;
    private String specialist;
    private ZonedDateTime date;
    private PatientEntity patient;
    private MeasurementPostModel measurement;
    private String diagnosis;
    private String treatment;
    private Set<SymptomEntity> symptoms;
    private Set<FileEntity> files;
}
