package es.mdef.mipediatra.models.consultation;

import es.mdef.mipediatra.constants.ConsultationType;
import es.mdef.mipediatra.entities.PatientEntity;
import es.mdef.mipediatra.entities.SymptomEntity;
import es.mdef.mipediatra.models.PutModel;
import es.mdef.mipediatra.models.measurement.MeasurementPutModel;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.ZonedDateTime;
import java.util.Set;

@EqualsAndHashCode(callSuper = true)
@Data
public class ConsultationPutModel extends PutModel {
    private ConsultationType type;
    private String center;
    private String comments;
    private String specialist;
    private ZonedDateTime date;
    private PatientEntity patient;
    private MeasurementPutModel measurement;
    private String diagnosis;
    private String treatment;
    private Set<SymptomEntity> symptoms;
}