package es.mdef.mipediatra.models.patient;

import es.mdef.mipediatra.constants.PatientType;
import es.mdef.mipediatra.entities.AutonomousCommunityEntity;
import es.mdef.mipediatra.entities.FileEntity;
import es.mdef.mipediatra.models.PutModel;
import es.mdef.mipediatralib.constants.BloodType;
import es.mdef.mipediatralib.constants.Gender;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.hateoas.server.core.Relation;

import java.time.ZonedDateTime;

@Relation(itemRelation = "patient")
@EqualsAndHashCode(callSuper = true)
@Data
public class PatientPutModel extends PutModel {
    private String comments;
    private FileEntity photo;
    private PatientType type;
    private String name;
    private String lastName;
    private Gender gender;
    private double birthWeight;
    private AutonomousCommunityEntity autonomousCommunity;
    private BloodType bloodType;
    private ZonedDateTime birthdate;
}