package es.mdef.mipediatra.services.impl;

import es.mdef.mipediatra.assemblers.MeasurementAssembler;
import es.mdef.mipediatra.entities.MeasurementEntity;
import es.mdef.mipediatra.models.measurement.MeasurementModel;
import es.mdef.mipediatra.models.measurement.MeasurementPostModel;
import es.mdef.mipediatra.models.measurement.MeasurementPutModel;
import es.mdef.mipediatra.models.measurement.MeasurementsListModel;
import es.mdef.mipediatra.repositories.MeasurementRepository;
import es.mdef.mipediatra.services.AssemblerService;
import es.mdef.mipediatra.services.CrudService;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Service;

@Service
public class MeasurementService implements CrudService<MeasurementEntity, MeasurementModel, MeasurementPostModel, MeasurementPutModel, MeasurementsListModel> {
    private final MeasurementRepository measurementRepository;
    private final MeasurementAssembler measurementAssembler;

    public MeasurementService(MeasurementRepository measurementRepository, MeasurementAssembler measurementAssembler) {
        this.measurementRepository = measurementRepository;
        this.measurementAssembler = measurementAssembler;
    }

    @Override
    public String getEntityName() {
        return "measurement";
    }

    @Override
    public JpaRepository<MeasurementEntity, Long> getRepository() {
        return measurementRepository;
    }

    @Override
    public AssemblerService<MeasurementEntity, MeasurementModel, MeasurementPostModel, MeasurementPutModel, MeasurementsListModel> getAssembler() {
        return measurementAssembler;
    }
}
