package es.mdef.mipediatra.services.impl;

import es.mdef.mipediatra.assemblers.SymptomAssembler;
import es.mdef.mipediatra.entities.SymptomEntity;
import es.mdef.mipediatra.models.PostModel;
import es.mdef.mipediatra.models.PutModel;
import es.mdef.mipediatra.models.symptom.SymptomModel;
import es.mdef.mipediatra.models.symptom.SymptomsListModel;
import es.mdef.mipediatra.repositories.SymptomRepository;
import es.mdef.mipediatra.services.AssemblerService;
import es.mdef.mipediatra.services.CrudService;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Service;

@Service
public class SymptomService implements CrudService<SymptomEntity, SymptomModel, PostModel, PutModel, SymptomsListModel> {
    private final SymptomRepository symptomRepository;
    private final SymptomAssembler symptomAssembler;

    public SymptomService(SymptomRepository symptomRepository, SymptomAssembler symptomAssembler) {
        this.symptomRepository = symptomRepository;
        this.symptomAssembler = symptomAssembler;
    }

    @Override
    public String getEntityName() {
        return "symptom";
    }

    @Override
    public JpaRepository<SymptomEntity, Long> getRepository() {
        return symptomRepository;
    }

    @Override
    public AssemblerService<SymptomEntity, SymptomModel, PostModel, PutModel, SymptomsListModel> getAssembler() {
        return symptomAssembler;
    }
}
